<?php
/**
 * Plugin Name: EP Upsell
 * Version:     1.0.0
 * Author:      Elektronika Perhoč
 * Author URI:  http://ep.hr/
 */



add_action('ep_archive_after_content', function() {
    $category = get_queried_object();

    if (!$category instanceof WP_Term) {
        return;
    }

    $productIds = [];

    if ($skus = get_term_meta($category->term_id, '_upsale_artcodes', true)) {
        $skus = explode(';', $skus);
        $productIds = array_map('wc_get_product_id_by_sku', $skus);
    }

    $tecdoc = ep_tecdoc_service();

    if ($genArtIds = get_term_meta($category->term_id, '_upsale_tecdoc_artid', true)) {
        $genArtIds = array_map('absint', explode(';', $genArtIds));

        if (count($articles = $tecdoc->getArticlesByGenericIds($genArtIds)) > 0) {
            $articleKeys = [];

            foreach ($articles as $article) {
                $articleKeys[] = sprintf("'%s'", $article['key']);
            }

            global $wpdb;


            $ids = $wpdb->get_col("SELECT post_id FROM wp_postmeta WHERE meta_key = '_tecDoc_key' AND meta_value IN(" . implode(',', $articleKeys) . ")");
            $productIds = array_merge($productIds, array_map('absint', $ids));
        }
    }

    if (count($productIds) === 0) {
        return;
    }

    /** @var \WC_Product[] $unsorted */
    $unsorted = wc_get_products([
        'limit' => -1,
        'status' => 'publish',
        'include' => $productIds,
    ]);

    $byId = [];

    foreach ($unsorted as $product) {
        $byId[$product->get_id()] = $product;
    }

    $products = [];

    foreach ($productIds as $product_id) {
        $products[] = $byId[$product_id];
    }

    include __DIR__ . '/templates/container.php';
});

add_action('wp_enqueue_scripts', function() {
    if (is_archive() && is_product_category()) {
        $manifest = json_decode(file_get_contents(__DIR__ . '/dist/manifest.json'), true);
        wp_enqueue_style('upsell', plugin_dir_url(__FILE__) . '/dist/' . $manifest['ep-upsell.css']);
        wp_enqueue_script('upsell', plugin_dir_url(__FILE__) . '/dist/' . $manifest['ep-upsell.js'], ['jquery']);
    }
});